﻿Imports System.Windows.Forms
Imports System.Collections
Imports SolidWorks.Interop.sldworks
Imports SolidWorks.Interop.swconst

Public Class Dialog1
    Public pfad As String
    Private swapp As SldWorks
    Public ok As Integer
    Public create As Boolean = False

    Private pass_IO As New Passungstabelle_IO
    Private formate As ArrayList
    Private sprachen As ArrayList
    Private format As Passungstabelle_IO.Format_Einstellung = New Passungstabelle_IO.Format_Einstellung


    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        If pass_IO.write_INI(formate, pfad) = True And pass_IO.write_lang(sprachen, pfad) = True Then
            MsgBox("Einstellungen gespeichert", vbMsgBoxSetForeground + vbInformation, "Meldung")
        Else
            MsgBox("Problem beim Speichern der Einstellungen", vbMsgBoxSetForeground + vbInformation, "Meldung")
        End If
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim d2 As New Dialog2

        If format.TABTYPE = 1 Or format.TABTYPE = 0 Then
            d2.PictureBox1.Select()
            d2.PictureBox1.BorderStyle = BorderStyle.FixedSingle
            d2.PictureBox2.BorderStyle = BorderStyle.None
            d2.PictureBox3.BorderStyle = BorderStyle.None
        ElseIf format.TABTYPE = 2 Then
            d2.PictureBox2.Select()
            d2.PictureBox2.BorderStyle = BorderStyle.FixedSingle
            d2.PictureBox1.BorderStyle = BorderStyle.None
            d2.PictureBox3.BorderStyle = BorderStyle.None
        Else
            d2.PictureBox3.Select()
            d2.PictureBox3.BorderStyle = BorderStyle.FixedSingle
            d2.PictureBox1.BorderStyle = BorderStyle.None
            d2.PictureBox2.BorderStyle = BorderStyle.None
        End If
        d2.ShowDialog()
        If d2.PictureBox1.BorderStyle = BorderStyle.FixedSingle Then
            format.TABTYPE = 1
        ElseIf d2.PictureBox2.BorderStyle = BorderStyle.FixedSingle Then
            format.TABTYPE = 2
        Else
            format.TABTYPE = 3
        End If
        formate.Item(ListBox1.SelectedIndex) = format
        d2.Dispose()
    End Sub


    Private Sub Dialog1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim antw As MsgBoxResult
        ok = False
        swapp = CreateObject("SldWorks.Application")
        'pfad = swapp.GetCurrentMacroPathFolder()
        'pfad = swapp.GetCurrentMacroPathName

        format = Nothing
        formate = pass_IO.read_all(pfad)
        If IsNothing(formate) And create = False Then
            antw = MsgBox("INI-Datei nicht gefunden" & Chr(10) & "soll die Datei neu erstellt werden?", MsgBoxStyle.YesNo, "Meldung")
            If antw = MsgBoxResult.Yes Then
                create = True
            Else
                create = False
                ok = -1
            End If
        End If
        If (IsNothing(formate) And create = True) Or Not IsNothing(formate) Then
            If IsNothing(formate) Then
                MsgBox("INI-Datei wurde nicht gefunden" & Chr(10) & "Date wird neu erstellt", MsgBoxStyle.OkOnly, "Meldung")
            End If
            sprachen = pass_IO.read_lang(pfad)
            If sprachen.Count > 0 Then
                fill_form(0)
                If Not IsNothing(formate) Then ListBox1.SelectedIndex = 0
                ok = 1
            Else
                ok = -1
                Me.Close()
            End If
        Else
            Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
            Me.Close()
        End If
    End Sub
    Private Sub fill_form(ByVal idx As Integer)
        Dim format_temp As New Passungstabelle_IO.Format_Einstellung
        Dim sprache As Passungstabelle_IO.Sprache
        Dim its() As ListViewItem
        Dim i, y As Integer
        Dim temp As String

        If Not IsNothing(formate) Then format_temp = formate.Item(idx)

        ListView1.Clear()
        ListView1.Columns.Add("Sprache", -2, HorizontalAlignment.Left)
        ListView1.Columns.Add("Passung", -2, HorizontalAlignment.Left)
        ListView1.Columns.Add("Toleranz", -2, HorizontalAlignment.Left)
        ListView1.Columns.Add("Abmaße", -2, HorizontalAlignment.Left)
        ListView1.Columns.Add("Vorbearbeitung", -2, HorizontalAlignment.Left)
        ListView1.Columns.Add("Maß", -2, HorizontalAlignment.Left)
        ListView1.Columns.Add("Zone", -2, HorizontalAlignment.Left)

        For i = 0 To sprachen.Count - 1
            If i = 0 Then
                ReDim its(0)
            Else
                ReDim Preserve its(i)
            End If
            its(i) = New ListViewItem

            sprache = sprachen.Item(i)

            its(i).SubItems(0).Text = sprache.kennung
            its(i).SubItems.Add(sprache.pass)
            its(i).SubItems.Add(sprache.Tol)
            its(i).SubItems.Add(sprache.Abm)
            its(i).SubItems.Add(sprache.vor)
            its(i).SubItems.Add(sprache.masz)
            its(i).SubItems.Add(sprache.zon)
        Next i

        ListView1.Items.AddRange(its)

        y = 0
        ComboBox3.Items.Clear()

        For i = 0 To ListView1.Items.Count - 1
            ComboBox3.Items.Add(ListView1.Items(i).Text)
        Next i

        For i = 0 To ListView1.Items.Count - 1
            temp = ComboBox3.Items(i)
            For y = 0 To ListView1.Items.Count - 1
                If ComboBox3.Items(y) <> temp Then
                    ComboBox3.Items.Add(temp & "/" & ComboBox3.Items(y))
                End If
            Next y
        Next i
        ComboBox3.Sorted = True

        If Not IsNothing(formate) Then ComboBox3.SelectedIndex = ComboBox3.FindStringExact(format_temp.HEADER_LANG) Else ComboBox3.SelectedIndex = 0

        ListBox1.Items.Clear()
        If Not IsNothing(formate) Then
            For Each format_temp In formate
                ListBox1.Items.Add(format_temp.P_Format)
            Next
        End If

        ' ListBox1.SelectedIndex = ListBox1.FindStringExact(format_temp.P_Format)

        If Not IsNothing(formate) Then Me.Text = "Einstellungen Passungstabelle - " + format_temp.P_Format Else Me.Text = "Einstellungen Passungstabelle - "

        TABR.Items.Clear()
        TABR.Items.Add("Kein")
        TABR.Items.Add("Dünn")
        TABR.Items.Add("Normal")
        TABR.Items.Add("Dick")
        TABR.Items.Add("Dick(2)")
        TABR.Items.Add("Dick(3)")
        TABR.Items.Add("Dick(4)")
        TABR.Items.Add("Dick(5)")
        TABR.Items.Add("Dick(6)")

        If Not IsNothing(formate) Then TABR.SelectedIndex = format_temp.TABBorder Else TABR.SelectedIndex = 0


        TABG.Items.Clear()
        TABG.Items.Add("Kein")
        TABG.Items.Add("Dünn")
        TABG.Items.Add("Normal")
        TABG.Items.Add("Dick")
        TABG.Items.Add("Dick(2)")
        TABG.Items.Add("Dick(3)")
        TABG.Items.Add("Dick(4)")
        TABG.Items.Add("Dick(5)")
        TABG.Items.Add("Dick(6)")

        If Not IsNothing(formate) Then TABG.SelectedIndex = format_temp.TABGrid Else TABG.SelectedIndex = 0

        If Not IsNothing(formate) Then
            OFX.Text = format_temp.OFFSET_X * 1000.0
            OFY.Text = format_temp.OFFSET_Y * 1000.0
            COLW_1.Text = format_temp.CW1 * 1000.0
            COLW_2.Text = format_temp.CW2 * 1000.0
            COLW_3.Text = format_temp.CW3 * 1000.0
            COLW_4.Text = format_temp.CW4 * 1000.0
            If format_temp.INSERT_POINT = "LO" Then
                EP_LO.Checked = True
            ElseIf format_temp.INSERT_POINT = "RO" Then
                EP_RO.Checked = True
            ElseIf format_temp.INSERT_POINT = "LU" Then
                EP_LU.Checked = True
            ElseIf format_temp.INSERT_POINT = "RU" Then
                EP_RU.Checked = True
            End If

            TEXT_SIZE.Text = format_temp.TEXT_HIGH * 1000.0
            TEXT_STYLE.Text = format_temp.T_Stil
            TEXT_KIND.Text = format_temp.T_Art

            PAGE_W.Text = format_temp.F_B * 1000.0
            PAGE_H.Text = format_temp.F_H * 1000.0

            If format_temp.Empty_Pass = "ignore" Then
                EF_IG.Checked = True
                EF_WA.Checked = False
            Else
                EF_IG.Checked = False
                EF_WA.Checked = True
            End If

            If format_temp.HEADER = "KOPFZEILE" Then
                HEAD_UP.Checked = True
                HEAD_DOWN.Checked = False
            Else
                HEAD_UP.Checked = False
                HEAD_DOWN.Checked = True
            End If

            If format_temp.PLUS = "+" Then
                PLUS.Checked = True
            Else
                PLUS.Checked = False
            End If

            If format_temp.SST = 0 Then
                VB_NO.Checked = True
                VB_AS.Checked = False
                VB_FI.Checked = False
                VB.Enabled = False
            ElseIf format_temp.SST = 1 Then
                VB_NO.Checked = False
                VB_AS.Checked = True
                VB_FI.Checked = False
                VB.Enabled = False
            Else
                VB_NO.Checked = False
                VB_AS.Checked = False
                VB_FI.Checked = True
                VB.Enabled = True
                VB.Text = format_temp.SST_V
            End If
            BOR_U.Text = format_temp.BOR_U * 1000.0
            BOR_D.Text = format_temp.BOR_D * 1000.0
            BOR_R.Text = format_temp.BOR_R * 1000.0
            BOR_L.Text = format_temp.BOR_L * 1000.0

            P_ROW.Text = format_temp.P_ROW
            P_COL.Text = format_temp.P_COL
        End If
    End Sub
    Private Sub fill_form_chg(ByVal idx As Integer)
        Dim format_temp As Passungstabelle_IO.Format_Einstellung


        format_temp = formate.Item(idx)

        ComboBox3.SelectedIndex = ComboBox3.FindStringExact(format_temp.HEADER_LANG)

        Me.Text = "Einstellungen Passungstabelle - " + format_temp.P_Format

        TABR.SelectedIndex = format_temp.TABBorder

        TABG.SelectedIndex = format_temp.TABGrid


        OFX.Text = format_temp.OFFSET_X * 1000.0
        OFY.Text = format_temp.OFFSET_Y * 1000.0
        COLW_1.Text = format_temp.CW1 * 1000.0
        COLW_2.Text = format_temp.CW2 * 1000.0
        COLW_3.Text = format_temp.CW3 * 1000.0
        COLW_4.Text = format_temp.CW4 * 1000.0
        If format_temp.INSERT_POINT = "LO" Then
            EP_LO.Checked = True
        ElseIf format_temp.INSERT_POINT = "RO" Then
            EP_RO.Checked = True
        ElseIf format_temp.INSERT_POINT = "LU" Then
            EP_LU.Checked = True
        ElseIf format_temp.INSERT_POINT = "RU" Then
            EP_RU.Checked = True
        End If

        TEXT_SIZE.Text = format_temp.TEXT_HIGH * 1000.0
        TEXT_STYLE.Text = format_temp.T_Stil
        TEXT_KIND.Text = format_temp.T_Art

        PAGE_W.Text = format_temp.F_B * 1000
        PAGE_H.Text = format_temp.F_H * 1000

        If format_temp.Empty_Pass = "ignore" Then
            EF_IG.Checked = True
            EF_WA.Checked = False
        Else
            EF_IG.Checked = False
            EF_WA.Checked = True
        End If

        If format_temp.PLUS = "+" Then
            PLUS.Checked = True
        Else
            PLUS.Checked = False
        End If

        If format_temp.SST = 0 Then
            VB_NO.Checked = True
            VB_AS.Checked = False
            VB_FI.Checked = False
            VB.Enabled = False
        ElseIf format_temp.SST = 1 Then
            VB_NO.Checked = False
            VB_AS.Checked = True
            VB_FI.Checked = False
            VB.Enabled = False
        Else
            VB_NO.Checked = False
            VB_AS.Checked = True
            VB_FI.Checked = False
            VB.Enabled = True
            VB.Text = format_temp.SST_V
        End If

        BOR_U.Text = format_temp.BOR_U * 1000.0
        BOR_D.Text = format_temp.BOR_D * 1000.0
        BOR_R.Text = format_temp.BOR_R * 1000.0
        BOR_L.Text = format_temp.BOR_L * 1000.0

        P_ROW.Text = format_temp.P_ROW
        P_COL.Text = format_temp.P_COL

        If format_temp.SHOW_ZONES = 1 Then
            Show_Zones.Checked = True
        Else
            Show_Zones.Checked = False
        End If

    End Sub

    Private Sub fill_form_lang(ByVal idx As Integer)
        Dim format_temp As New Passungstabelle_IO.Format_Einstellung
        Dim sprache As Passungstabelle_IO.Sprache
        Dim its() As ListViewItem
        Dim i, y As Integer
        Dim temp, old As String

        format_temp = formate.Item(idx)

        ListView1.Clear()

        ListView1.Columns.Add("Sprache", -2, HorizontalAlignment.Left)
        ListView1.Columns.Add("Passung", -2, HorizontalAlignment.Left)
        ListView1.Columns.Add("Toleranz", -2, HorizontalAlignment.Left)
        ListView1.Columns.Add("Abmaße", -2, HorizontalAlignment.Left)
        ListView1.Columns.Add("Vorbearbeitung", -2, HorizontalAlignment.Left)
        ListView1.Columns.Add("Maß", -2, HorizontalAlignment.Left)
        ListView1.Columns.Add("Zone", -2, HorizontalAlignment.Left)
        ListView1.Columns(0).Width = 75
        ListView1.Columns(1).Width = 95
        ListView1.Columns(2).Width = 95
        ListView1.Columns(3).Width = 95
        ListView1.Columns(4).Width = 100
        ListView1.Columns(5).Width = 109
        ListView1.Columns(6).Width = 100

        For i = 0 To sprachen.Count - 1
            If i = 0 Then
                ReDim its(0)
            Else
                ReDim Preserve its(i)
            End If
            its(i) = New ListViewItem

            sprache = sprachen.Item(i)

            its(i).SubItems(0).Text = sprache.kennung
            its(i).SubItems.Add(sprache.pass)
            its(i).SubItems.Add(sprache.Tol)
            its(i).SubItems.Add(sprache.Abm)
            its(i).SubItems.Add(sprache.vor)
            its(i).SubItems.Add(sprache.masz)
            its(i).SubItems.Add(sprache.zon)
        Next i

        ListView1.Items.AddRange(its)

        y = 0

        old = ComboBox3.Text

        ComboBox3.Items.Clear()

        For i = 0 To ListView1.Items.Count - 1
            ComboBox3.Items.Add(ListView1.Items(i).Text)
        Next i

        For i = 0 To ListView1.Items.Count - 1
            temp = ListView1.Items(i).Text
            For y = 0 To ListView1.Items.Count - 1

                If ListView1.Items(y).Text <> temp Then
                    ComboBox3.Items.Add(temp & "/" & ListView1.Items(y).Text)
                End If
            Next y
        Next i
        ComboBox3.Sorted = True
        ComboBox3.Text = old
    End Sub


    Private Sub Button2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        FontDialog1.Font = New System.Drawing.Font(TEXT_STYLE.Text, TEXT_SIZE.Text)
        If FontDialog1.ShowDialog <> Windows.Forms.DialogResult.Cancel Then
            TEXT_STYLE.Text = FontDialog1.Font.Name
            format.T_Stil = FontDialog1.Font.Name
            TEXT_SIZE.Text = FontDialog1.Font.Size
            format.TEXT_HIGH = Math.Round(FontDialog1.Font.Size / 1000, 1)
            TEXT_KIND.Text = FontDialog1.Font.Style.ToString
            format.T_Art = FontDialog1.Font.Style.ToString
        End If
        formate.Item(ListBox1.SelectedIndex) = format
    End Sub


    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        If ListBox1.SelectedIndex > -1 Then
            format = formate.Item(ListBox1.SelectedIndex)
            fill_form_chg(ListBox1.SelectedIndex)
        End If

    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click

        Dim nf As String
        Dim i As Integer
        Dim va1 As Object
        Dim temp_format As Passungstabelle_IO.Format_Einstellung

        va1 = get_sheet_prop()

        If va1 Is Nothing Then
            nf = InputBox("Formatname", "Format hinzufügen", "")
        Else
            If va1(1) <> "" Then
                nf = InputBox("Formatname", "Format hinzufügen", va1(1))
            Else
                nf = InputBox("Formatname", "Format hinzufügen", "")
            End If
        End If


        If nf <> "" Then
            For i = 0 To ListBox1.Items.Count - 1
                If UCase(ListBox1.Items(i)) = UCase(nf) Then
                    MsgBox("Es gibt bereits ein Format mit diesem Namen", vbMsgBoxSetForeground + vbInformation, "Meldung")
                    Exit Sub
                End If
            Next i

            temp_format = New Passungstabelle_IO.Format_Einstellung

            If formate.Count > 0 Then
                temp_format = formate(ListBox1.SelectedIndex)
                If Not va1 Is Nothing Then
                    If va1(2) = "german" Then
                        temp_format.HEADER_LANG = "DE"
                    Else
                        temp_format.HEADER_LANG = "EN"
                    End If
                    temp_format.P_Format = nf
                    temp_format.F_B = va1(0)(5)
                    temp_format.F_H = va1(0)(6)
                Else
                    temp_format.HEADER_LANG = "DE"
                    temp_format.P_Format = nf
                    temp_format.F_B = 210 / 1000
                    temp_format.F_H = 297 / 1000
                End If
            Else
                With temp_format
                    .INSERT_POINT = "RO"
                    .OFFSET_X = 0
                    .OFFSET_Y = 0
                    .TEXT_HIGH = 0.0025
                    .CW1 = 0.008
                    .CW2 = 0.008
                    .CW3 = 0.008
                    .CW4 = 0.008
                    .DEC = 8
                    .PLUS = "+"
                    .T_Stil = "Arial"
                    .T_Art = "Standard"
                    .T_Unter = False
                    .T_Durch = False
                    .Empty_Pass = "ignore"
                    .F_B = 0
                    .F_H = 0
                    .P_Format = nf
                    .TABTYPE = 1
                    .TABBorder = 3
                    .TABGrid = 1
                    .HEADER = "KOPFZEILE"
                    If va1(2) = "german" Then
                        .HEADER_LANG = "DE"
                    Else
                        .HEADER_LANG = "EN"
                    End If
                End With
            End If
            formate.Add(temp_format)
            ListBox1.Items.Add(nf)
            'Form_INI.Frame1.Caption = "Einstellungen für Format - " + nf
            Me.Text = "Einstellungen für Passungstabelle / Format - " + nf
            ListBox1.SelectedIndex = ListBox1.Items.Count - 1
            fill_form_chg(ListBox1.SelectedIndex)
        End If
    End Sub

    Function get_sheet_prop() As Object
        Dim swmodel As ModelDoc2
        Dim swSheet As Object
        Dim vSheetProps As Object
        Dim tempname As String
        Dim temp(2) As Object


        swmodel = swapp.ActiveDoc
        If swmodel Is Nothing Then
            MsgBox("Keine Zeichnung geladen!", vbMsgBoxSetForeground + vbInformation, "Fehler")
            get_sheet_prop = Nothing
            Exit Function
        End If
        '* Prüfung ob das aktuell aktive Dokument eine Zeichnung ist
        If swmodel.GetType <> swDocumentTypes_e.swDocDRAWING Then
            MsgBox("Aktive Datei ist keine Zeichnung!", vbMsgBoxSetForeground + vbInformation, "Fehler")
            'get_sheet_prop = Nothing
            get_sheet_prop = Nothing
            Exit Function
        End If

        swSheet = swmodel.GetCurrentSheet

        vSheetProps = swSheet.GetProperties
        tempname = Mid(swSheet.GetTemplateName, InStrRev(swSheet.GetTemplateName, "\") + 1)
        tempname = Strings.Left(tempname, Len(tempname) - 7)

        temp(0) = vSheetProps
        temp(1) = tempname
        temp(2) = swapp.GetCurrentLanguage

        swSheet = Nothing
        swmodel = Nothing


        get_sheet_prop = temp

    End Function


    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        Dim pos As Integer

        pos = ListBox1.SelectedIndex
        If ListBox1.SelectedIndex >= 0 Then
            formate.RemoveAt(pos)
            ListBox1.Items.RemoveAt(pos)
            ListBox1.SelectedIndex = 0
            fill_form_chg(0)
        End If
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim temp_format As Passungstabelle_IO.Format_Einstellung
        Dim va1 As Object

        If ListBox1.SelectedIndex <> -1 Then
            temp_format = format
            va1 = get_sheet_prop()
            If Not va1 Is Nothing Then
                temp_format.F_B = va1(0)(5)
                temp_format.F_H = va1(0)(6)
                formate.Item(ListBox1.SelectedIndex) = temp_format
                format = temp_format
                PAGE_W.Text = format.F_B * 1000
                PAGE_H.Text = format.F_H * 1000
            End If
        Else
            MsgBox("Kein Format gewählt", MsgBoxStyle.OkOnly, "Meldung")
        End If
    End Sub

    Private Sub EP_RO_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EP_RO.CheckedChanged
        If Not (format.P_Format Is Nothing) And EP_RO.Checked = True Then
            format.INSERT_POINT = "RO"
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub EP_LO_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EP_LO.CheckedChanged
        If Not (format.P_Format Is Nothing) And EP_LO.Checked = True Then
            format.INSERT_POINT = "LO"
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub EP_LU_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EP_LU.CheckedChanged
        If Not (format.P_Format Is Nothing) And EP_LU.Checked = True Then
            format.INSERT_POINT = "LU"
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub EP_RU_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EP_RU.CheckedChanged
        If Not (format.P_Format Is Nothing) And EP_RU.Checked = True Then
            format.INSERT_POINT = "RU"
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub OFX_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OFX.TextChanged
        If Not (format.P_Format Is Nothing) And OFX.Text <> "" Then
            If IsNumeric(OFX.Text) Then
                format.OFFSET_X = OFX.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                OFX.Text = ""
            End If
        End If
    End Sub

    Private Sub OFY_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OFY.TextChanged
        If Not (format.P_Format Is Nothing) And OFY.Text <> "" Then
            If IsNumeric(OFY.Text) Then
                format.OFFSET_Y = OFY.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                OFY.Text = ""
            End If
        End If
    End Sub

    Private Sub COLW_1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles COLW_1.TextChanged
        If Not (format.P_Format Is Nothing) And COLW_1.Text <> "" Then
            If IsNumeric(COLW_1.Text) Then
                format.CW1 = COLW_1.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                COLW_1.Text = ""
            End If
        End If
    End Sub

    Private Sub COLW_2_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles COLW_2.TextChanged
        If Not (format.P_Format Is Nothing) And COLW_2.Text <> "" Then
            If IsNumeric(COLW_2.Text) Then
                format.CW2 = COLW_2.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                COLW_2.Text = ""
            End If
        End If
    End Sub

    Private Sub COLW_3_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles COLW_3.TextChanged
        If Not (format.P_Format Is Nothing) And COLW_3.Text <> "" Then
            If IsNumeric(COLW_3.Text) Then
                format.CW3 = COLW_3.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                COLW_3.Text = ""
            End If
        End If
    End Sub

    Private Sub COLW_4_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles COLW_4.TextChanged
        If Not (format.P_Format Is Nothing) And COLW_4.Text <> "" Then
            If IsNumeric(COLW_4.Text) Then
                format.CW4 = COLW_4.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                COLW_4.Text = ""
            End If
        End If
    End Sub

    Private Sub TABR_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TABR.SelectedIndexChanged
        If Not (format.P_Format Is Nothing) Then
            format.TABBorder = TABR.SelectedIndex
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub TABG_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TABG.SelectedIndexChanged
        If Not (format.P_Format Is Nothing) Then
            format.TABGrid = TABG.SelectedIndex
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub HEAD_UP_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HEAD_UP.CheckedChanged
        If Not (format.P_Format Is Nothing) And HEAD_UP.Checked = True Then
            If Not (format.P_Format Is Nothing) Then
                format.HEADER = "KOPFZEILE"
                formate.Item(ListBox1.SelectedIndex) = format
            End If
        End If
    End Sub

    Private Sub HEAD_DOWN_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HEAD_DOWN.CheckedChanged
        If Not (format.P_Format Is Nothing) And HEAD_DOWN.Checked = True Then
            format.HEADER = "FUSSZEILE"
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub PAGE_W_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PAGE_W.TextChanged
        If Not (format.P_Format Is Nothing) And PAGE_W.Text <> "" Then
            If IsNumeric(PAGE_W.Text) Then
                format.F_B = PAGE_W.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                PAGE_W.Text = ""
            End If
        End If
    End Sub

    Private Sub PAGE_H_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PAGE_H.TextChanged
        If Not (format.P_Format Is Nothing) And PAGE_H.Text <> "" Then
            If IsNumeric(PAGE_H.Text) Then
                format.F_H = PAGE_H.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                PAGE_H.Text = ""
            End If
        End If
    End Sub

    Private Sub EF_IG_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EF_IG.CheckedChanged
        If Not (format.P_Format Is Nothing) And EF_IG.Checked = True Then
            format.Empty_Pass = "ignore"
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub EF_WA_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EF_WA.CheckedChanged
        If Not (format.P_Format Is Nothing) And EF_WA.Checked = True Then
            format.Empty_Pass = "warn"
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub VB_NO_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VB_NO.CheckedChanged
        If Not (format.P_Format Is Nothing) And VB_NO.Checked = True Then
            VB.Enabled = False
            VB.Text = ""
            format.SST = 0
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub VB_AS_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VB_AS.CheckedChanged
        If Not (format.P_Format Is Nothing) And VB_AS.Checked = True Then
            VB.Enabled = False
            VB.Text = ""
            format.SST = 1
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub VB_FI_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VB_FI.CheckedChanged
        If Not (format.P_Format Is Nothing) And VB_FI.Checked = True Then
            format.SST = 2
            VB.Enabled = True
            If VB.Text = "" Then
                VB.Text = "0.02"
            End If
            If IsNumeric(VB.Text) And Val(VB.Text) > 0 Then
                format.SST_V = VB.Text / 1000
            End If
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub VB_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VB.TextChanged
        If Not (format.P_Format Is Nothing) And VB.Text <> "" Then
            If IsNumeric(VB.Text) Then
                format.SST_V = VB.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                VB.Text = ""
            End If
        End If
    End Sub

    Private Sub PLUS_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PLUS.CheckedChanged
        If Not (format.P_Format Is Nothing) Then
            If PLUS.Checked = True Then
                format.PLUS = "+"
            Else
                format.PLUS = "-"
            End If
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub ComboBox3_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox3.SelectedIndexChanged
        If Not (format.P_Format Is Nothing) Then
            format.HEADER_LANG = ComboBox3.Text
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim codes As ArrayList
        Dim d3 As New Dialog4
        Dim its() As ListViewItem
        Dim i As Integer
        Dim temp As Passungstabelle_IO.Sprache
        Dim temp1 As Passungstabelle_IO.sprachen
        Dim temps As String

        codes = pass_IO.get_lang_codes()

        temps = ComboBox3.Text

        d3.ListView1.Clear()
        d3.ListView1.Columns.Add("Kennung", -2, HorizontalAlignment.Left)
        d3.ListView1.Columns.Add("Sprache", -2, HorizontalAlignment.Left)

        For i = 0 To codes.Count - 1
            If i = 0 Then
                ReDim its(0)
            Else
                ReDim Preserve its(i)
            End If
            its(i) = New ListViewItem
            temp1 = codes.Item(i)
            its(i).SubItems(0).Text = temp1.kennung
            its(i).SubItems.Add(temp1.sprache)
        Next i

        d3.ListView1.Items.AddRange(its)
        d3.ShowDialog()
        If d3.DialogResult = Windows.Forms.DialogResult.OK Then
            For i = 0 To ListView1.Items.Count - 1
                If ListView1.Items(i).SubItems(0).Text = d3.TextBox1.Text Then
                    MsgBox("Diese Sprache existiert bereits", MsgBoxStyle.OkOnly, "Fehler")
                    Exit Sub
                End If
            Next
            temp = New Passungstabelle_IO.Sprache
            temp.kennung = d3.TextBox1.Text
            temp.pass = d3.TextBox2.Text
            temp.Tol = d3.TextBox3.Text
            temp.Abm = d3.TextBox4.Text
            temp.vor = d3.TextBox5.Text
            temp.masz = d3.TextBox6.Text
            temp.zon = d3.TextBox7.Text
            sprachen.Add(temp)
            format = formate.Item(ListBox1.SelectedIndex)
            fill_form_lang(ListBox1.SelectedIndex)
        End If

        ComboBox3.Text = temps
        d3.Dispose()

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim temps As String
        Dim temp_f As New Passungstabelle_IO.Format_Einstellung

        If Not ListView1.FocusedItem Is Nothing Then
            temps = ListView1.SelectedItems.Item(0).SubItems(0).Text
            For Each temp_f In formate
                If temp_f.HEADER_LANG = temps Then
                    MsgBox("Sie können die Sprache nicht löschen, weil sie von einer Formateinstellung verwendet wird!", MsgBoxStyle.OkOnly, "Meldung")
                    Exit Sub
                End If
            Next
            sprachen.RemoveAt(ListView1.FocusedItem.Index)
            fill_form_lang(ListBox1.SelectedIndex)
        Else
            MsgBox("Sie haben keinen Eintrag gewählt!", MsgBoxStyle.OkOnly, "Meldung")
        End If
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim temp_f As New Passungstabelle_IO.Sprache
        Dim d3 As New Dialog3

        If Not ListView1.FocusedItem Is Nothing Then
            d3.TextBox1.Text = ListView1.SelectedItems.Item(0).SubItems(0).Text
            d3.TextBox2.Text = ListView1.SelectedItems.Item(0).SubItems(1).Text
            d3.TextBox3.Text = ListView1.SelectedItems.Item(0).SubItems(2).Text
            d3.TextBox4.Text = ListView1.SelectedItems.Item(0).SubItems(3).Text
            d3.TextBox5.Text = ListView1.SelectedItems.Item(0).SubItems(4).Text
            d3.TextBox6.Text = ListView1.SelectedItems.Item(0).SubItems(5).Text
            d3.TextBox7.Text = ListView1.SelectedItems.Item(0).SubItems(6).Text

            d3.ShowDialog()

            If d3.DialogResult = Windows.Forms.DialogResult.OK Then
                temp_f.kennung = d3.TextBox1.Text
                temp_f.pass = d3.TextBox2.Text
                temp_f.Tol = d3.TextBox3.Text
                temp_f.Abm = d3.TextBox4.Text
                temp_f.vor = d3.TextBox5.Text
                temp_f.masz = d3.TextBox6.Text
                temp_f.zon = d3.TextBox7.Text
                sprachen.Item(ListView1.FocusedItem.Index) = temp_f
                fill_form_lang(0)
            End If


        Else
            MsgBox("Sie haben keinen Eintrag gewählt!", MsgBoxStyle.OkOnly, "Meldung")
        End If
    End Sub


    Private Sub TEXT_SIZE_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TEXT_SIZE.TextChanged
        If Not (format.P_Format Is Nothing) And TEXT_SIZE.Text <> "" Then
            If IsNumeric(TEXT_SIZE.Text) Then
                format.TEXT_HIGH = TEXT_SIZE.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                TEXT_SIZE.Text = ""
            End If
        End If
    End Sub


    Private Sub BOR_U_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BOR_U.TextChanged
        If Not (format.P_Format Is Nothing) And BOR_U.Text <> "" Then
            If IsNumeric(BOR_U.Text) Then
                format.BOR_U = BOR_U.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                BOR_U.Text = ""
            End If
        End If
    End Sub

    Private Sub BOR_D_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BOR_D.TextChanged
        If Not (format.P_Format Is Nothing) And BOR_D.Text <> "" Then
            If IsNumeric(BOR_D.Text) Then
                format.BOR_D = BOR_D.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                BOR_D.Text = ""
            End If
        End If
    End Sub

    Private Sub BOR_L_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BOR_L.TextChanged
        If Not (format.P_Format Is Nothing) And BOR_L.Text <> "" Then
            If IsNumeric(BOR_L.Text) Then
                format.BOR_L = BOR_L.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                BOR_L.Text = ""
            End If
        End If
    End Sub

    Private Sub BOR_R_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BOR_R.TextChanged
        If Not (format.P_Format Is Nothing) And BOR_R.Text <> "" Then
            If IsNumeric(BOR_R.Text) Then
                format.BOR_R = BOR_R.Text / 1000
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Zahl!", MsgBoxStyle.Information, "Meldung")
                BOR_R.Text = ""
            End If
        End If
    End Sub


    Private Sub P_ROW_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P_ROW.TextChanged
        If Not (format.P_Format Is Nothing) And P_ROW.Text <> "" Then
            P_ROW.Text = Replace(P_ROW.Text, ",", ".")
            If IsNumeric(P_ROW.Text) And Int(Val(P_ROW.Text)) - Val(P_ROW.Text) = 0 Then
                format.P_ROW = P_ROW.Text
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Ganzzahl!", MsgBoxStyle.Information, "Meldung")
                P_ROW.Text = ""
            End If
        End If
    End Sub

    Private Sub P_COL_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P_COL.TextChanged
        If Not (format.P_Format Is Nothing) And P_COL.Text <> "" Then
            P_COL.Text = Replace(P_COL.Text, ",", ".")
            If IsNumeric(P_COL.Text) And Int(Val(P_COL.Text)) - Val(P_COL.Text) = 0 Then
                format.P_COL = P_COL.Text
                formate.Item(ListBox1.SelectedIndex) = format
            Else
                MsgBox("Keine Ganzzahl!", MsgBoxStyle.Information, "Meldung")
                P_COL.Text = ""
            End If
        End If
    End Sub


    Private Sub Label25_Click(sender As Object, e As EventArgs) Handles Label25.Click

    End Sub

    Private Sub Show_Zones_CheckedChanged(sender As Object, e As EventArgs) Handles Show_Zones.CheckedChanged
        If Not (format.P_Format Is Nothing) Then
            If Show_Zones.Checked = True Then
                format.SHOW_ZONES = 1
            Else
                format.SHOW_ZONES = 0
            End If
            formate.Item(ListBox1.SelectedIndex) = format
        End If
    End Sub
End Class
