Imports System.Collections
Imports System
Imports System.IO
Imports System.Text
Imports System.Runtime.InteropServices
Imports Microsoft.Office.Interop

Public Class Passungstabelle_IO
    Public Structure Format_Einstellung
        Public INSERT_POINT As String
        Public OFFSET_X As Double
        Public OFFSET_Y As Double
        Public TEXT_HIGH As Double
        Public CW1 As Double
        Public CW2 As Double
        Public CW3 As Double
        Public CW4 As Double
        Public DEC As Integer
        Public PLUS As String
        Public T_Stil As String
        Public T_Art As String
        Public T_Unter As Boolean
        Public T_Durch As Boolean
        Public Empty_Pass As String
        Public F_B As Double
        Public F_H As Double
        Public P_Format As String
        Public HEADER As String
        Public HEADER_LANG As String
        Public TABTYPE As Byte
        Public TABBorder As Integer
        Public TABGrid As Integer
        Public SST As Byte
        Public SST_V As Double
        Public BOR_D As Double
        Public BOR_U As Double
        Public BOR_R As Double
        Public BOR_L As Double
        Public P_ROW As Byte
        Public P_COL As Byte
        Public SHOW_ZONES As Byte
    End Structure
    Public Structure Sprache
        Public kennung As String
        Public pass As String
        Public Tol As String
        Public Abm As String
        Public vor As String
        Public masz As String
        Public zon As String
    End Structure
    Public Structure sprachen
        Public kennung As String
        Public sprache As String
    End Structure

    Private formate_array As New ArrayList()
    Private sprach_array As New ArrayList
    Private sprachen_array As New ArrayList

    Property data() As ArrayList
        Get
            Return formate_array
        End Get
        Set(ByVal Value As ArrayList)
            formate_array = Value
        End Set
    End Property

    WriteOnly Property setformat() As Format_Einstellung
        Set(ByVal value As Format_Einstellung)
            For Each ff As Format_Einstellung In formate_array
                If ff.P_Format = value.P_Format Then
                    ff = value
                End If
            Next
        End Set
    End Property

    ReadOnly Property getformat(ByVal formats As String) As Format_Einstellung
        Get
            For Each ff As Format_Einstellung In formate_array
                If ff.P_Format = formats Then
                    getformat = ff
                    Exit Property
                End If
            Next
            getformat = Nothing
        End Get
    End Property

    ReadOnly Property get_lang_codes() As ArrayList
        Get
            get_lang_codes = sprachen_array
        End Get
    End Property

    ReadOnly Property get_sprachen() As ArrayList
        Get
            get_sprachen = sprach_array
        End Get
    End Property

    Public Function del_format(ByVal formats As String) As ArrayList
        Dim i As Integer

        i = 0
        For Each ff As Format_Einstellung In formate_array
            If ff.P_Format = formats Then
                formate_array.RemoveAt(i)
                del_format = formate_array
            End If
            formate_array.RemoveAt(i)
            del_format = formate_array
            Exit Function
            i = i + 1
        Next
        del_format = Nothing
    End Function

    Public Function read_all(ByVal pfad As String) As ArrayList
        Dim zeile As String
        Dim gef As Boolean
        Dim i As Integer
        Dim file As FileIO.FileSystem()
        Dim P_Form As Format_Einstellung

        gef = False

        If formate_array.Count > 0 Then
            formate_array.Clear()
        End If



        On Error GoTo nextline

        Dim sw As StreamReader = New StreamReader(pfad + "\" + "Passungstabelle.ini")

        i = -1
        Do While sw.Peek() >= 0
            zeile = sw.ReadLine()
            If Left(zeile, 2) = "##" Then
                gef = True
                i = i + 1
            End If
        Loop
        If gef = False Then
            MsgBox("keine Daten gefunden", vbMsgBoxSetForeground + vbInformation, "Fehler")
            read_all = Nothing
            Exit Function
        End If
        sw.Close()


        i = 0

        sw = New StreamReader(pfad + "\" + "Passungstabelle.ini")
        zeile = ""
        Do While sw.Peek() >= 0
            If Left(zeile, 2) = "##" And i = 0 Then
                P_Form = New Format_Einstellung
                i = i + 1
                P_Form.P_Format = Mid(zeile, 3)
            ElseIf Left(zeile, 2) = "##" And i > 0 Then
                formate_array.Add(P_Form)
                P_Form = New Format_Einstellung
                i = i + 1
                P_Form.P_Format = Mid(zeile, 3)
            End If
            If zeile = "#EP" Then
                zeile = sw.ReadLine()
                P_Form.INSERT_POINT = zeile
            ElseIf zeile = "#C1" Then
                zeile = sw.ReadLine()
                P_Form.CW1 = Val(zeile)
            ElseIf zeile = "#FB" Then
                zeile = sw.ReadLine()
                P_Form.F_B = Val(zeile)
            ElseIf zeile = "#FH" Then
                zeile = sw.ReadLine()
                P_Form.F_H = Val(zeile)
            ElseIf zeile = "#C2" Then
                zeile = sw.ReadLine()
                P_Form.CW2 = Val(zeile)
            ElseIf zeile = "#C3" Then
                zeile = sw.ReadLine()
                P_Form.CW3 = Val(zeile)
            ElseIf zeile = "#C4" Then
                zeile = sw.ReadLine()
                P_Form.CW4 = Val(zeile)
            ElseIf zeile = "#OPX" Then
                zeile = sw.ReadLine()
                P_Form.OFFSET_X = Val(zeile)
            ElseIf zeile = "#OPY" Then
                zeile = sw.ReadLine()
                P_Form.OFFSET_Y = Val(zeile)
            ElseIf zeile = "#DEC" Then
                zeile = sw.ReadLine()
                P_Form.DEC = CInt(zeile)
            ElseIf zeile = "#TH" Then
                zeile = sw.ReadLine()
                P_Form.TEXT_HIGH = Val(zeile)
            ElseIf zeile = "#TS" Then
                zeile = sw.ReadLine()
                P_Form.T_Stil = zeile
            ElseIf zeile = "#TK" Then
                zeile = sw.ReadLine()
                P_Form.T_Art = zeile
            ElseIf zeile = "#TU" Then
                zeile = sw.ReadLine()
                If zeile = "0" Then P_Form.T_Durch = False Else P_Form.T_Durch = True
            ElseIf zeile = "#TD" Then
                zeile = sw.ReadLine()
                If zeile = "0" Then P_Form.T_Unter = False Else P_Form.T_Unter = False
            ElseIf zeile = "#PLUS" Then
                zeile = sw.ReadLine()
                P_Form.PLUS = zeile
            ElseIf zeile = "#SST" Then
                zeile = sw.ReadLine()
                If Left(zeile, 3) = "Non" Then P_Form.SST = 0
                If Left(zeile, 3) = "Inp" Then P_Form.SST = 1
                If Left(zeile, 3) = "Fix" Then P_Form.SST = 2
                If P_Form.SST = 2 Then P_Form.SST_V = Val(Replace(Mid(zeile, 4), ",", "."))
            ElseIf zeile = "#LEER" Then
                zeile = sw.ReadLine()
                P_Form.Empty_Pass = zeile
            ElseIf zeile = "#HEADER" Then
                zeile = sw.ReadLine()
                P_Form.HEADER = zeile
            ElseIf zeile = "#HEADER-LANG" Then
                zeile = sw.ReadLine()
                P_Form.HEADER_LANG = zeile
            ElseIf zeile = "#TABTYPE" Then
                zeile = sw.ReadLine()
                P_Form.TABTYPE = zeile
            ElseIf zeile = "#TABBORDER" Then
                zeile = sw.ReadLine()
                P_Form.TABBorder = zeile
            ElseIf zeile = "#TABGRID" Then
                zeile = sw.ReadLine()
                P_Form.TABGrid = zeile
            ElseIf zeile = "#BOR_U" Then
                zeile = sw.ReadLine()
                P_Form.BOR_U = zeile
            ElseIf zeile = "#BOR_D" Then
                zeile = sw.ReadLine()
                P_Form.BOR_D = zeile
            ElseIf zeile = "#BOR_R" Then
                zeile = sw.ReadLine()
                P_Form.BOR_R = zeile
            ElseIf zeile = "#BOR_L" Then
                zeile = sw.ReadLine()
                P_Form.BOR_L = zeile
            ElseIf zeile = "#P_ROW" Then
                zeile = sw.ReadLine()
                P_Form.P_ROW = zeile
            ElseIf zeile = "#P_COL" Then
                zeile = sw.ReadLine()
                P_Form.P_COL = zeile
            ElseIf zeile = "#P_ZONES" Then
                zeile = sw.ReadLine()
                P_Form.SHOW_ZONES = zeile
            Else
            End If
            If sw.Peek() >= 0 Then zeile = sw.ReadLine()

        Loop
        sw.Close()
        formate_array.Add(P_Form)
        read_all = formate_array
        Exit Function
nextline:
        On Error GoTo 0
        'MsgBox("INI_Datei nicht gefunden oder Fehler beim Lesen der INI-Datei" + Chr(10) + "Die Datei wird neu erstellt", vbInformation, "Fehler")
        read_all = Nothing
    End Function

    Public Function read_lang(ByVal pfad As String) As ArrayList
        Dim exc As Excel.Application
        Dim wbs As Excel.Workbooks
        Dim wb As Excel.Workbook
        Dim x, y As Integer
        Dim L_Form As Sprache
        Dim L1_Form As sprachen


        If Dir(pfad + "\" + "Sprachen.xls") <> "" Then
            exc = CreateObject("Excel.Application")
            exc.Visible = False
            wbs = exc.Workbooks
            wb = wbs.Open(pfad & "\" & "Sprachen.xls")
        Else
            MsgBox("Datei Sprachen-XLS nicht gefunden", vbCritical, "Fehler")
            read_lang = Nothing
            Exit Function
        End If
        x = 2
        y = 2

        sprach_array.Clear()
        While wb.Sheets(1).cells(y, x).value <> ""
            L_Form = New Sprache

            L_Form.kennung = wb.Sheets(1).cells(y, x).value
            L_Form.pass = wb.Sheets(1).cells(y, x + 1).value
            L_Form.Tol = wb.Sheets(1).cells(y, x + 2).value
            L_Form.Abm = wb.Sheets(1).cells(y, x + 3).value
            L_Form.vor = wb.Sheets(1).cells(y, x + 4).value
            L_Form.masz = wb.Sheets(1).cells(y, x + 5).value
            L_Form.zon = wb.Sheets(1).cells(y, x + 6).value

            y = y + 1

            sprach_array.Add(L_Form)
        End While

        x = 1
        y = 2

        sprachen_array.Clear()
        While wb.Sheets(2).cells(y, x).value <> ""
            L1_Form = New sprachen
            L1_Form.kennung = wb.Sheets(2).cells(y, x).value
            L1_Form.sprache = wb.Sheets(2).cells(y, x + 1).value
            y = y + 1
            sprachen_array.Add(L1_Form)
        End While

        wb.Close()
        exc.Quit()
        releaseObject(exc)
        releaseObject(wbs)
        releaseObject(wb)

        read_lang = sprach_array
    End Function

    Public Function read_lang_codes(ByVal pfad As String) As ArrayList
        Dim exc As Excel.Application
        Dim wbs As Excel.Workbooks
        Dim wb As Excel.Workbook
        Dim x, y As Integer
        Dim L_Form As sprachen

        If sprach_array.Count > 0 Then
            sprach_array.Clear()
        End If

        If Dir(pfad + "\" + "Sprachen.xls") <> "" Then
            exc = CreateObject("Excel.Application")
            exc.Visible = False
            wbs = exc.Workbooks
            wb = wbs.Open(pfad & "\" & "Sprachen.xls")
        Else
            MsgBox("Datei Sprachen-XLS nicht gefunden", vbCritical, "Fehler")
            read_lang_codes = Nothing
            Exit Function
        End If
        x = 1
        y = 2

        sprach_array.Clear()
        While wb.Sheets(2).cells(y, 1).value <> ""
            L_Form = New sprachen
            L_Form.kennung = wb.Sheets(2).cells(y, x).value
            L_Form.sprache = wb.Sheets(2).cells(y, x + 1).value
            y = y + 1
            sprachen_array.Add(L_Form)
        End While

        wb.Close()
        exc.Quit()
        releaseObject(exc)
        releaseObject(wbs)
        releaseObject(wb)
        read_lang_codes = sprachen_array
    End Function

    Public Function write_INI(ByVal formate_lst As ArrayList, ByVal pfad As String) As Boolean
        Dim zeile As String
        Dim temp As Passungstabelle_IO.Format_Einstellung
        Dim ok As Boolean

        ok = False
        On Error GoTo ErrorHandler

        Dim sw As StreamWriter = New StreamWriter(pfad + "\" + "Passungstabelle.ini")

        For Each temp In formate_lst
            sw.WriteLine("##" + temp.P_Format)
            sw.WriteLine("#EP")
            sw.WriteLine(temp.INSERT_POINT)
            sw.WriteLine("#FB")
            sw.WriteLine(Replace(temp.F_B, ",", ".", 1))
            sw.WriteLine("#FH")
            sw.WriteLine(Replace(temp.F_H, ",", ".", 1))
            sw.WriteLine("#OPX")
            sw.WriteLine(Replace(temp.OFFSET_X, ",", ".", 1))
            sw.WriteLine("#OPY")
            sw.WriteLine(Replace(temp.OFFSET_Y, ",", ".", 1))
            sw.WriteLine("#DEC")
            sw.WriteLine(temp.DEC)
            sw.WriteLine("#C1")
            sw.WriteLine(Replace(temp.CW1, ",", ".", 1))
            sw.WriteLine("#C2")
            sw.WriteLine(Replace(temp.CW2, ",", ".", 1))
            sw.WriteLine("#C3")
            sw.WriteLine(Replace(temp.CW3, ",", ".", 1))
            sw.WriteLine("#C4")
            sw.WriteLine(Replace(temp.CW4, ",", ".", 1))
            sw.WriteLine("#TH")
            sw.WriteLine(Replace(temp.TEXT_HIGH, ",", ".", 1))
            sw.WriteLine("#TS")
            sw.WriteLine(temp.T_Stil)
            sw.WriteLine("#TK")
            sw.WriteLine(temp.T_Art)
            sw.WriteLine("#TU")
            If temp.T_Unter = False Then sw.WriteLine("0") Else sw.WriteLine("1")
            sw.WriteLine("#TD")
            If temp.T_Durch = False Then sw.WriteLine("0") Else sw.WriteLine("1")
            sw.WriteLine("#PLUS")
            sw.WriteLine(temp.PLUS)
            sw.WriteLine("#LEER")
            sw.WriteLine(temp.Empty_Pass)
            sw.WriteLine("#HEADER")
            sw.WriteLine(temp.HEADER)
            sw.WriteLine("#HEADER-LANG")
            sw.WriteLine(temp.HEADER_LANG)
            sw.WriteLine("#TABTYPE")
            sw.WriteLine(temp.TABTYPE)
            sw.WriteLine("#TABBORDER")
            sw.WriteLine(temp.TABBorder)
            sw.WriteLine("#TABGRID")
            sw.WriteLine(temp.TABGrid)
            sw.WriteLine("#SST")
            If temp.SST = 0 Then sw.WriteLine("Non")
            If temp.SST = 1 Then sw.WriteLine("Inp")
            If temp.SST = 2 Then
                sw.WriteLine("Fix" & temp.SST_V)
            End If
            sw.WriteLine("#BOR_U")
            sw.WriteLine(temp.BOR_U)
            sw.WriteLine("#BOR_D")
            sw.WriteLine(temp.BOR_D)
            sw.WriteLine("#BOR_R")
            sw.WriteLine(temp.BOR_R)
            sw.WriteLine("#BOR_L")
            sw.WriteLine(temp.BOR_L)
            sw.WriteLine("#P_COL")
            sw.WriteLine(temp.P_COL)
            sw.WriteLine("#P_ROW")
            sw.WriteLine(temp.P_ROW)
            sw.WriteLine("#P_ZONES")
            sw.WriteLine(temp.SHOW_ZONES)
        Next

        sw.Close()
        write_INI = True
        Exit Function
ErrorHandler:
        If Err.Number <> 0 Then
            MsgBox("Konnte Datei Setup.ini nicht ffnen", MsgBoxStyle.Critical, "Fehler")
            write_INI = False
        End If
    End Function

    Public Function write_lang(ByVal sprachen_lst As ArrayList, ByVal pfad As String) As Boolean
        Dim exc As Excel.Application
        Dim wbs As Excel.Workbooks
        Dim wb As Excel.Workbook
        Dim x, y As Integer
        Dim L_Form As Sprache


        If Dir(pfad + "\" + "Sprachen.xls") <> "" Then
            exc = CreateObject("Excel.Application")
            exc.Visible = False
            wbs = exc.Workbooks
            wb = wbs.Open(pfad & "\" & "Sprachen.xls")
        Else
            MsgBox("Datei Sprachen-XLS nicht gefunden", vbCritical, "Fehler")
            write_lang = False
            Exit Function
        End If
        x = 2
        y = 2

        While wb.Sheets(1).cells(y, x).value <> ""
            wb.Sheets(1).cells(y, x - 1).value = ""
            wb.Sheets(1).cells(y, x).value = ""
            wb.Sheets(1).cells(y, x + 1).value = ""
            wb.Sheets(1).cells(y, x + 2).value = ""
            wb.Sheets(1).cells(y, x + 3).value = ""
            wb.Sheets(1).cells(y, x + 4).value = ""
            wb.Sheets(1).cells(y, x + 5).value = ""
            wb.Sheets(1).cells(y, x + 6).value = ""
            y = y + 1
        End While

        x = 1
        y = 2
        For Each L_Form In sprachen_lst
            wb.Sheets(1).cells(y, x).value = y - 1
            wb.Sheets(1).cells(y, x + 1).value = L_Form.kennung
            wb.Sheets(1).cells(y, x + 2).value = L_Form.pass
            wb.Sheets(1).cells(y, x + 3).value = L_Form.Tol
            wb.Sheets(1).cells(y, x + 4).value = L_Form.Abm
            wb.Sheets(1).cells(y, x + 5).value = L_Form.vor
            wb.Sheets(1).cells(y, x + 6).value = L_Form.masz
            wb.Sheets(1).cells(y, x + 7).value = L_Form.zon
            y = y + 1
        Next

        wb.Save()
        wb.Close()
        exc.Quit()
        releaseObject(exc)
        releaseObject(wbs)

        write_lang = True
    End Function

    Private Sub releaseObject(ByVal obj As Object)
        Try
            System.Runtime.InteropServices.Marshal.ReleaseComObject(obj)
            obj = Nothing
        Catch ex As Exception
            obj = Nothing
        Finally
            GC.Collect()
        End Try
    End Sub


End Class
