﻿Imports SolidWorks.Interop.sldworks
Imports SolidWorks.Interop.swconst
Imports SolidWorks.Interop.swpublished
Imports SolidWorksTools
Imports SolidWorksTools.File

Imports System.Collections.Generic


Module Passungstabelle
    Public pfad As String
    Private pass_IO As New Passungstabelle_IO
    Private formate As New ArrayList
    Private sprachen As New ArrayList
    Private format As Passungstabelle_IO.Format_Einstellung = New Passungstabelle_IO.Format_Einstellung
    Private langg As Passungstabelle_IO.Sprache = New Passungstabelle_IO.Sprache
    Private abfr_stat As Integer

    Public Structure pass_obj
        Dim passung As String
        Dim zones As String
    End Structure
    '** Abfrage für Schichtstärke für Vorbearbeitungsmaß
    Private Function Abfrage_VBA() As Double
        Dim abf As New VBA_Wert
        Dim d1 As Double

        abf.ShowDialog()
        If abf.stat = 1 And abf.TextBox1.Text <> "" Then
            d1 = CDbl(abf.TextBox1.Text)
        Else
            d1 = 0
        End If
        abfr_stat = abf.stat
        abf.Dispose()
        Abfrage_VBA = d1
    End Function

    Private Function GetDimFactor(swDim As SolidWorks.Interop.sldworks.Dimension) As Double
        Const PI As Double = 3.14159265
        Const LEN_FACTOR As Double = 1000.0#
        Const ANG_FACTOR As Double = 180.0# / PI

        Select Case swDim.GetType
            Case swDimensionParamType_e.swDimensionParamTypeDoubleLinear
                GetDimFactor = LEN_FACTOR
            Case swDimensionParamType_e.swDimensionParamTypeDoubleAngular
                GetDimFactor = ANG_FACTOR
        End Select
    End Function

    Private Function check(dliste As ArrayList, suf As String, m As String, p As String, tp As Double, tm As Double) As ArrayList
        Dim i As Integer
        i = 0

        If dliste.Count > 0 Then
            While i < dliste.Count - 1 And dliste(i) <> suf & Chr(9) & m & Chr(9) & p & Chr(9) & tp & Chr(9) & tm
                i = i + 1
            End While
        End If

        If tp = 0 And tm = 0 Then
            MsgBox("Achtung keine gültige Passung gefunden für " & m & "(" & p & ")", vbInformation, "Meldung")
        Else
            If dliste.Count = 0 Then
                dliste.Add(suf & Chr(9) & m & Chr(9) & p & Chr(9) & tp & Chr(9) & tm)
            Else
                If dliste(i) <> suf + Chr(9) & m & Chr(9) & p & Chr(9) & tp & Chr(9) & tm Then
                    dliste.Add(suf & Chr(9) & m & Chr(9) & p & Chr(9) & tp & Chr(9) & tm)
                End If
            End If
        End If
        check = dliste
    End Function

    Private Function check1(dliste As List(Of pass_obj), suf As String, m As String, p As String, tp As Double, tm As Double, zone As Byte, ep As System.Object, actformat As Passungstabelle_IO.Format_Einstellung) As List(Of pass_obj)
        Dim i As Integer
        Dim temp As New pass_obj

        i = 0

        If dliste.Count > 0 Then
            While i < dliste.Count - 1 And dliste(i).passung <> suf & Chr(9) & m & Chr(9) & p & Chr(9) & tp & Chr(9) & tm
                i = i + 1
            End While
        End If

        If tp = 0 And tm = 0 Then
            MsgBox("Achtung keine gültige Passung gefunden für " & m & "(" & p & ")", vbInformation, "Meldung")
        Else
            If dliste.Count = 0 Then
                temp.passung = suf & Chr(9) & m & Chr(9) & p & Chr(9) & tp & Chr(9) & tm
                If zone = 1 Then
                    temp.zones = temp.zones + calc_zone(actformat, ep)
                Else
                    temp.zones = ""
                End If
                dliste.Add(temp)
            Else
                If dliste(i).passung <> suf + Chr(9) & m & Chr(9) & p & Chr(9) & tp & Chr(9) & tm Then
                    temp.passung = suf & Chr(9) & m & Chr(9) & p & Chr(9) & tp & Chr(9) & tm
                    If zone = 1 Then
                        temp.zones = temp.zones + calc_zone(actformat, ep)
                    Else
                        temp.zones = ""
                    End If
                    dliste.Add(temp)
                End If
            End If
        End If
        check1 = dliste
    End Function

    Function calc_zone(actformat As Passungstabelle_IO.Format_Einstellung, ep As System.Object) As String
        Dim x, y, dx, dy, w, h, sw As Double

        Dim py, px, zone As String

        w = actformat.F_B * 1000
        h = actformat.F_H * 1000
        dx = (w - actformat.BOR_L - actformat.BOR_R) / actformat.P_COL
        dy = (h - actformat.BOR_D - actformat.BOR_U) / actformat.P_ROW

        x = ep(0) * 1000
        y = h - (ep(1) * 1000)

        sw = dx + actformat.BOR_L
        px = 0
        For i = 1 To actformat.P_COL
            If x <= sw Then
                px = i
                Exit For
            End If
            sw = sw + dx
        Next i

        sw = dy + actformat.BOR_U
        py = 0
        For i = 1 To actformat.P_ROW
            If y <= sw Then
                py = i
                Exit For
            End If
            sw = sw + dy
        Next i

        py = Chr(64 + py)

        zone = py & "/" & px

        calc_zone = zone
     

    End Function
    '** Passungsliste aufsteigend sortieren
    Function sort_up(dliste As ArrayList) As ArrayList
        Dim ok As Boolean
        Dim i As Integer
        Dim suf, suf1 As String
        Dim t2, t21 As String
        Dim masz, masz1 As Double
        Dim temp As String

        ok = False

        '* Wenn die Liste kein od. nur ein Element enthält
        '* dann gibt es auch nichts zu sortieren
        If dliste.Count <= 1 Then
            sort_up = dliste
            Exit Function
        End If

        For i = 0 To dliste.Count - 1
            suf = Left(dliste(i), InStr(dliste(i), Chr(9)) - 1)
            t2 = Mid(dliste(i), InStr(dliste(i), Chr(9)) + 1)
            masz = Val(Left(t2, InStr(t2, Chr(9))))
            If i < dliste.Count - 1 Then
                suf1 = Left(dliste(i + 1), InStr(dliste(i + 1), Chr(9)) - 1)
                t21 = Mid(dliste(i + 1), InStr(dliste(i + 1), Chr(9)) + 1)
                masz1 = Val(Left(t21, InStr(t21, Chr(9))))
                If masz > masz1 Then
                    temp = dliste(i + 1)
                    dliste(i + 1) = dliste(i)
                    dliste(i) = temp
                    i = -1
                End If
            End If
        Next i
        sort_up = dliste
    End Function
    '** Passungsliste absteigend sortieren
    Function sort_down(dliste As ArrayList) As ArrayList
        Dim ok As Boolean
        Dim i As Integer
        Dim suf, suf1 As String
        Dim t2, t21 As String
        Dim masz, masz1 As Double
        Dim temp As String

        ok = False

        '* Wenn die Liste kein od. nur ein Element enthält
        '* dann gibt es auch nichts zu sortieren
        If dliste.Count <= 1 Then
            sort_down = dliste
            Exit Function
        End If

        For i = 0 To dliste.Count - 1
            suf = Left(dliste(i), InStr(dliste(i), Chr(9)) - 1)
            t2 = Mid(dliste(i), InStr(dliste(i), Chr(9)) + 1)
            masz = Val(Left(t2, InStr(t2, Chr(9))))
            If i < dliste.Count - 1 Then
                suf1 = Left(dliste(i + 1), InStr(dliste(i + 1), Chr(9)) - 1)
                t21 = Mid(dliste(i + 1), InStr(dliste(i + 1), Chr(9)) + 1)
                masz1 = Val(Left(t21, InStr(t21, Chr(9))))

                If masz < masz1 Then
                    temp = dliste(i + 1)
                    dliste(i + 1) = dliste(i)
                    dliste(i) = temp
                    i = -1
                End If
            End If
        Next i
        sort_down = dliste
    End Function

    Private Function get_lang(lang As String) As Passungstabelle_IO.Sprache
        Dim temp1, temp2 As New Passungstabelle_IO.Sprache
        Dim c1, c2 As String

        If InStr(lang, "/") = 0 Then
            c1 = lang
            c2 = ""
        Else
            c1 = Left(lang, InStr(lang, "/") - 1)
            c2 = Right(lang, InStrRev(lang, "/") - 1)
        End If

        For Each temp1 In sprachen
            If temp1.kennung = c1 Then
                Exit For
            End If
        Next

        If c2 <> "" Then
            For Each temp2 In sprachen
                If temp2.kennung = c2 Then
                    Exit For
                End If
            Next
            temp1.kennung = temp1.kennung & "/" & temp2.kennung
            temp1.Abm = temp1.Abm & "/" & temp2.Abm
            temp1.masz = temp1.masz & "/" & temp2.masz
            temp1.pass = temp1.pass & "/" & temp2.pass
            temp1.Tol = temp1.Tol & "/" & temp2.Tol
            temp1.vor = temp1.vor & "/" & temp2.vor
            temp1.zon = temp1.zon & "/" & temp2.zon
            get_lang = temp1
            Exit Function
        Else
            get_lang = temp1
            Exit Function
        End If

        get_lang = Nothing
    End Function

    '** Hauptprozedur
    '** fügt die Passungstabelle ein
    Sub passungstabelle(swapp As SldWorks)
        Dim P_Form As New ArrayList
        Dim swmodel As SolidWorks.Interop.sldworks.ModelDoc2
        Dim swdraw As SolidWorks.Interop.sldworks.DrawingDoc
        Dim swsheet As SolidWorks.Interop.sldworks.Sheet
        Dim swview As SolidWorks.Interop.sldworks.View
        Dim swDispDim As SolidWorks.Interop.sldworks.DisplayDimension
        Dim swdim As SolidWorks.Interop.sldworks.Dimension
        Dim btol As SolidWorks.Interop.sldworks.DimensionTolerance
        Dim swTable, swhtable As SolidWorks.Interop.sldworks.TableAnnotation
        Dim swhtab As SolidWorks.Interop.sldworks.HoleTable
        Dim tbf As SolidWorks.Interop.sldworks.Feature
        Dim swann As SolidWorks.Interop.sldworks.Annotation
        Dim textf As SolidWorks.Interop.sldworks.TextFormat
        Dim vsheetprops As System.Object
        Dim vsheetpropso As System.Object
        Dim nDimFactor As Double
        Dim formgef, keine_passungen, tabexists As Boolean
        Dim Tol(1) As String
        Dim temp, tempname As String
        Dim leere_gefunden As Boolean
        Dim swselmgr As SolidWorks.Interop.sldworks.SelectionMgr
        Dim swSelData As SolidWorks.Interop.sldworks.SelectData
        Dim formidx As Integer
        Dim x, y As Double
        Dim ii, xx As Integer
        Dim tto, ttu, masz, tolp, tolm As Double
        Dim th As Double
        Dim tt As String
        Dim pass, pass2, suf, t2 As String
        Dim dliste As New ArrayList
        Dim pass_lst As New List(Of pass_obj)
        Dim numsel, col_plus, tolpos As Integer
        Dim objs() As Object
        Dim zzz As Double


        format = Nothing
        If P_Form.Count > 0 Then
            P_Form.Clear()
        End If
        P_Form = pass_IO.read_all(pfad)
        formate = P_Form
        If sprachen.Count > 0 Then
            sprachen.Clear()
        End If

        sprachen = pass_IO.read_lang(pfad)


        leere_gefunden = False
        temp = "                                          "


        swmodel = swapp.ActiveDoc
        '* Prüfung ob ein Dokument aktiv ist
        If swmodel Is Nothing Then
            MsgBox("Keine Zeichnung geladen!", vbMsgBoxSetForeground + vbInformation, "Fehler")
            Exit Sub
        End If

        '* Prüfung ob das aktuell aktive Dokument eine Zeichnung ist
        If swmodel.GetType <> swDocumentTypes_e.swDocDRAWING Then
            MsgBox("Aktive Datei ist keine Zeichnung!", vbMsgBoxSetForeground + vbInformation, "Fehler")
            Exit Sub
        End If

        swselmgr = swmodel.SelectionManager
        swSelData = swselmgr.CreateSelectData

        swdraw = swmodel
        swsheet = swmodel.GetCurrentSheet
        vsheetprops = swsheet.GetProperties
        vsheetpropso = swsheet.GetProperties
        formgef = False

        '* Prüfung ob das aktuelle Blattformat in den SETUP-Einstellungen enthalten ist
        For formidx = 0 To P_Form.Count - 1
            tempname = Mid(swsheet.GetTemplateName, InStrRev(swsheet.GetTemplateName, "\") + 1)
            tempname = Left(tempname, Len(tempname) - 7)
            If P_Form(formidx).P_Format = tempname Then
                formgef = True
                Exit For
            End If
        Next formidx

        '* Prüfung ob die Abmessungen des aktuellen Blattformats in den SETUP-Einstellungen enthalten ist
        If formgef = False Then
            For formidx = 0 To P_Form.Count - 1
                If P_Form(formidx).F_B = vsheetprops(5) And P_Form(formidx).F_H = vsheetprops(6) Then
                    formgef = True
                    Exit For
                End If
            Next formidx
        End If

        '* Wenn das Blattformat nicht in den SETUP-Einstellungen gefunden wurde
        If formgef = False And P_Form.Count > 0 Then
            formidx = 0
        End If


        If P_Form.Count = 0 Then
            formgef = True
            formidx = 0
        End If

        '* Einfügepunkt für Tabelle an Hand der SETUP-Einstellungen festlegen
        If P_Form(formidx).INSERT_POINT = "LU" Then
            x = P_Form(formidx).OFFSET_X
            y = P_Form(formidx).OFFSET_Y
            ii = swBOMConfigurationAnchorType_e.swBOMConfigurationAnchor_BottomLeft
        ElseIf P_Form(formidx).INSERT_POINT = "LO" Then
            x = P_Form(formidx).OFFSET_X
            y = vsheetprops(6) - P_Form(formidx).OFFSET_Y
            ii = swBOMConfigurationAnchorType_e.swBOMConfigurationAnchor_TopLeft
        ElseIf P_Form(formidx).INSERT_POINT = "RO" Then
            x = vsheetprops(5) - P_Form(formidx).OFFSET_X
            y = vsheetprops(6) - P_Form(formidx).OFFSET_Y
            ii = swBOMConfigurationAnchorType_e.swBOMConfigurationAnchor_TopRight
        Else
            x = vsheetprops(5) - P_Form(formidx).OFFSET_X
            y = P_Form(formidx).OFFSET_Y
            ii = swBOMConfigurationAnchorType_e.swBOMConfigurationAnchor_BottomRight
        End If

        '* Prüfung wieviele Passungen vorhanden sind
        swview = swdraw.GetFirstView
        Do While Not swview Is Nothing
            swDispDim = swview.GetFirstDisplayDimension5
            Do While Not swDispDim Is Nothing
                swdim = swDispDim.GetDimension
                'es werden keine abgelösten Bemaßungen ausgewertet
                If swDispDim.GetAnnotation.IsDangling <> True Then
                    btol = swdim.Tolerance
                    nDimFactor = GetDimFactor(swdim)
                    Tol(0) = btol.GetShaftFitValue
                    Tol(1) = btol.GetHoleFitValue
                    tt = swdim.GetToleranceFitValues 'Passung
                    masz = Math.Round(swdim.GetSystemValue2("") * nDimFactor, P_Form(formidx).DEC)

                    pass = ""
                    pass2 = ""

                    For i = 0 To UBound(Tol)
                        If i = 0 And Tol(0) <> "" Then
                            btol.SetFitValues("", Tol(0))
                            pass = Tol(0)
                            pass2 = ""
                        End If
                        If i = 1 And Tol(1) <> "" Then
                            btol.SetFitValues(Tol(1), "")
                            pass = Tol(1)
                            pass2 = ""
                        End If
                        If (swdim.Tolerance.Type = swTolType_e.swTolFIT Or swdim.Tolerance.Type = swTolType_e.swTolFITWITHTOL Or swdim.Tolerance.Type = swTolType_e.swTolFITTOLONLY) And pass <> "" Then
                            If swdim.GetSystemValue2("") = 0 Then
                                MsgBox("                             Maß mit Wert 0 gefunden!" & Chr(10) & "Wahrscheinlich handelt es sich um eine abgelöste Zeichnung!" & Chr(10) & "                                 Makro wird beendet!", vbSystemModal + vbOKOnly, "Fehler")

                                Exit Sub
                            End If
                            '** Änderung Passung als Toleranz filtern
                            If (Left(pass, 1) >= "A" And Left(pass, 1) <= "Z") Or (Left(pass, 1) >= "a" And Left(pass, 1) <= "z") Then
                                tolp = btol.GetMaxValue * nDimFactor
                                tolm = btol.GetMinValue * nDimFactor
                                dliste = check(dliste, swDispDim.GetText(swDimensionTextParts_e.swDimensionTextPrefix), Trim(Str(masz)), pass, tolp, tolm)
                                pass_lst = check1(pass_lst, swDispDim.GetText(swDimensionTextParts_e.swDimensionTextPrefix), Trim(Str(masz)), pass, tolp, tolm, P_Form(formidx).SHOW_ZONES, swDispDim.GetAnnotation.getPosition, P_Form(formidx))

                            End If
                            '** Änderung Passung als Toleranz filtern
                            If (Left(pass2, 1) >= "A" And Left(pass2, 1) <= "Z") Or (Left(pass2, 1) >= "a" And Left(pass2, 1) <= "z") Then
                                If pass2 <> "" Then
                                    tolp = btol.GetMaxValue * nDimFactor
                                    tolm = btol.GetMinValue * nDimFactor
                                    dliste = check(dliste, swDispDim.GetText(swDimensionTextParts_e.swDimensionTextPrefix), Trim(Str(masz)), pass2, tolp, tolm)
                                    pass_lst = check1(pass_lst, swDispDim.GetText(swDimensionTextParts_e.swDimensionTextPrefix), Trim(Str(masz)), pass, tolp, tolm, P_Form(formidx).SHOW_ZONES, swDispDim.GetAnnotation.getPosition, P_Form(formidx))
                                End If
                            End If
                        End If
                    Next i
                    If Tol(0) <> "" And Tol(1) <> "" Then
                        btol.SetFitValues(Tol(1), Tol(0))
                    End If
                    Tol(0) = ""
                    Tol(1) = ""
                    If (swdim.Tolerance.Type = swTolType_e.swTolFIT Or swdim.Tolerance.Type = swTolType_e.swTolFITWITHTOL Or swdim.Tolerance.Type = swTolType_e.swTolFITTOLONLY) And pass = "" And pass2 = "" Then
                        leere_gefunden = True
                        If P_Form(formidx).Empty_Pass = "warn" Then
                            swDispDim.GetAnnotation.Select3(True, swSelData)
                        End If
                    End If
                End If
                swDispDim = swDispDim.GetNext5
            Loop
            swview = swview.GetNextView
        Loop



        '** Prüfung ob eine Bohrungstabelle vorhanden ist
        swview = swdraw.GetFirstView
        Do While Not swview Is Nothing
            swTable = swview.GetFirstTableAnnotation

            Do While Not swTable Is Nothing
                swann = swTable.GetAnnotation
                If swTable.Type = swTableAnnotationType_e.swTableAnnotation_HoleChart Then
                    swhtable = swTable
                    swhtab = swhtable.HoleTable


                    tbf = swhtab.GetFeature
                    swDispDim = tbf.GetFirstDisplayDimension

                    Do While Not swDispDim Is Nothing
                        swann = swDispDim.GetAnnotation
                        If swann.IsDangling <> True Then
                            swdim = swDispDim.GetDimension
                            btol = swdim.Tolerance
                            tt = swdim.GetToleranceFitValues
                            '---------------------------------------------------------------------------
                            nDimFactor = GetDimFactor(swdim)

                            masz = Math.Round(swdim.GetSystemValue2("") * nDimFactor, P_Form(formidx).DEC)

                            If swdim.GetToleranceFitValues <> "" Then
                                If Left(swdim.GetToleranceFitValues, 1) = "," Or Right(swdim.GetToleranceFitValues, 1) = "," Then
                                    If Left(swdim.GetToleranceFitValues, 1) = "," Then
                                        pass = Mid(swdim.GetToleranceFitValues, 2)
                                    ElseIf Right(swdim.GetToleranceFitValues, 1) = "," Then
                                        pass = Left(swdim.GetToleranceFitValues, Len(swdim.GetToleranceFitValues) - 1)
                                    End If
                                    pass2 = ""
                                Else
                                    pass = Left(swdim.GetToleranceFitValues, InStr(swdim.GetToleranceFitValues, ",") - 1)
                                    pass2 = Mid(swdim.GetToleranceFitValues, InStr(swdim.GetToleranceFitValues, ",") + 1)
                                End If
                            End If
                            If (swdim.Tolerance.Type = swTolType_e.swTolFIT Or swdim.Tolerance.Type = swTolType_e.swTolFITWITHTOL Or swdim.Tolerance.Type = swTolType_e.swTolFITTOLONLY) And pass <> "" Then
                                If swdim.GetSystemValue2("") = 0 Then
                                    MsgBox("                             Maß mit Wert 0 gefunden!" & Chr(10) & "Wahrscheinlich handelt es sich um eine abgelöste Zeichnung!" & Chr(10) & "                                 Makro wird beendet!", vbMsgBoxSetForeground + vbInformation, "Fehler")

                                    Exit Sub
                                End If
                                '** Änderung Passung als Toleranz filtern
                                If (Left(pass, 1) >= "A" And Left(pass, 1) <= "Z") Or (Left(pass, 1) >= "a" And Left(pass, 1) <= "z") Then
                                    '** Prüfung auf doppelte Einträge
                                    tolp = btol.GetMaxValue * nDimFactor
                                    tolm = btol.GetMinValue * nDimFactor
                                    dliste = check(dliste, swDispDim.GetText(swDimensionTextParts_e.swDimensionTextPrefix), Trim(Str(masz)), pass, tolp, tolm)
                                    pass_lst = check1(pass_lst, swDispDim.GetText(swDimensionTextParts_e.swDimensionTextPrefix), Trim(Str(masz)), pass, tolp, tolm, P_Form(formidx).SHOW_ZONES, swDispDim.GetAnnotation.getPosition, P_Form(formidx))
                                End If
                                '** Änderung Passung als Toleranz filtern
                                If (Left(pass2, 1) >= "A" And Left(pass2, 1) <= "Z") Or (Left(pass2, 1) >= "a" And Left(pass2, 1) <= "z") Then
                                    If pass2 <> "" Then
                                        '** Prüfung auf doppelte Einträge
                                        tolp = btol.GetMaxValue * nDimFactor
                                        tolm = btol.GetMinValue * nDimFactor
                                        dliste = check(dliste, swDispDim.GetText(swDimensionTextParts_e.swDimensionTextPrefix), Trim(Str(masz)), pass2, tolp, tolm)
                                        pass_lst = check1(pass_lst, swDispDim.GetText(swDimensionTextParts_e.swDimensionTextPrefix), Trim(Str(masz)), pass, tolp, tolm, P_Form(formidx).SHOW_ZONES, swDispDim.GetAnnotation.getPosition, P_Form(formidx))
                                    End If
                                End If
                            End If
                            '---------------------------------------------------------------------------
                            swDispDim = tbf.GetNextDisplayDimension(swDispDim)
                        End If
                    Loop
                End If
                swTable = swTable.GetNext
            Loop 'Do While Not swTable Is Nothing
            swview = swview.GetNextView
        Loop 'While Not swView Is Nothing


        If pass_lst.Count = 0 Then
            xx = 0
        Else
            xx = pass_lst.Count
        End If


        '* Passungen gefunden?
        If xx = 0 Then
            keine_passungen = True
            If P_Form(formidx).Empty_Pass = "ignore" Then
                MsgBox("Keine Passungen gefunden!", vbMsgBoxSetForeground + vbInformation, "Meldung")

                Exit Sub
            Else
                MsgBox("Die markierten Maße haben Passungen ohne Wert!", vbMsgBoxSetForeground + vbInformation, "Meldung")

                Exit Sub
            End If
        Else
            If leere_gefunden = True Then
                If P_Form(formidx).Empty_Pass = "warn" Then
                    MsgBox("Die markierten Maße haben Passungen ohne Wert!", vbMsgBoxSetForeground + vbInformation, "Meldung")
                    numsel = swmodel.SelectionManager.GetSelectedObjectCount
                    ReDim objs(numsel - 1)
                    For i = 0 To numsel - 1
                        objs(i) = swmodel.SelectionManager.GetSelectedObject6(i + 1, 0)
                    Next i
                End If
            End If
        End If



        tabexists = False
        '** Prüfung ob bereits eine Tabelle vorhanden ist
        swview = swdraw.GetFirstView
        Do While Not swview Is Nothing
            swTable = swview.GetFirstTableAnnotation
            Do While Not swTable Is Nothing
                swann = swTable.GetAnnotation
                '** Wenn eine Passungstabelle gefunden wurde
                If swann.GetName = "PASSUNGSTABELLE" Then
                    swann.Select(False)
                    '** Einfügepunkt speichern
                    ii = swTable.AnchorType
                    vsheetprops = swann.GetPosition
                    x = vsheetprops(0)
                    y = vsheetprops(1)
                    '** Tabelle löschen
                    swdraw.DeleteSelection(False)
                    tabexists = True
                    If keine_passungen = True Then

                        Exit Sub
                    End If
                    Exit Do
                End If
                swTable = swTable.GetNext
            Loop
            swview = swview.GetNextView
        Loop


        '** Wenn die Schichtstärke abgefragt werden soll
        If P_Form(formidx).SST = 1 Then
            zzz = Abfrage_VBA()
            format = P_Form(formidx)
            format.SST_V = zzz
            P_Form.Item(formidx) = format

            '** Wenn die Abfrage abgebrochen wurde oder nichts eingegeben wurde
            If abfr_stat = 0 Then
                MsgBox("Sie haben keine Schichtdicke eingegeben" + Chr(10) + "das Makro wird abgebrochen", vbMsgBoxSetForeground + vbInformation, "Fehler")

                Exit Sub
                '** Wenn 0 eingegeben wurde dann wird keine Schichtstärke berücksichtigt
            ElseIf abfr_stat = 1 And P_Form(formidx).SST_V = 0 Then
                P_Form(formidx).SST = 0
            End If
        End If

        If P_Form(formidx).HEADER_LANG = "" Then
            MsgBox("Achtung: es sind keine Spracheinstellungen hinterlegt" & Chr(10) & "bitte benutzen Sie das Setup um die Einstellungen vorzunehmen", vbCritical, "Fehler")
        End If

        '** Wenn keine Tabelle und kein passendes Format gefunden wurde
        If tabexists = False And formgef = False Then
            MsgBox("Das Format " + Trim(Str(vsheetprops(5) * 1000.0#)) + " x " + Trim(Str(vsheetprops(6) * 1000)) + " wurde nicht gefunden!" + Chr(10) + "Formatdaten werden vom ersten Format genommen", vbMsgBoxSetForeground + vbInformation, "Meldung")
        End If
        '** Wenn eine Tabelle und kein passendes Format gefunden wurde
        If tabexists = True And formgef = False Then
            MsgBox("Das Format " + Trim(Str(vsheetpropso(5) * 1000.0#)) + " x " + Trim(Str(vsheetpropso(6) * 1000)) + " wurde nicht gefunden!" + Chr(10) + "Tabelle wird an Position der vorhandenen Tabelle eingefügt", vbMsgBoxSetForeground + vbInformation, "Meldung")
        End If

        '* werden zusätzlich Spalten für das Vorbearbeitungsmaß benötigt
        If (P_Form(formidx).SST <> 0) And (P_Form(formidx).TABTYPE = 1 Or P_Form(formidx).TABTYPE = 0) Then
            col_plus = 2
        ElseIf (P_Form(formidx).SST <> 0) And (P_Form(formidx).TABTYPE = 2 Or P_Form(formidx).TABTYPE = 3) Then
            col_plus = 1
        Else
            col_plus = 0
        End If

        '* Tabelle einfügen
        If P_Form(formidx).TABTYPE = 1 Or P_Form(formidx).TABTYPE = 0 Then
            If P_Form(formidx).SHOW_ZONES = 0 Then
                swTable = swdraw.InsertTableAnnotation2(False, x, y, ii, "", xx * 2 + 1, 4 + col_plus)
            Else
                swTable = swdraw.InsertTableAnnotation2(False, x, y, ii, "", xx * 2 + 1, 5 + col_plus)
            End If
        Else
            If P_Form(formidx).SHOW_ZONES = 0 Then
                swTable = swdraw.InsertTableAnnotation2(False, x, y, ii, "", xx * 2 + 1, 2 + col_plus)
            Else
                swTable = swdraw.InsertTableAnnotation2(False, x, y, ii, "", xx * 2 + 1, 3 + col_plus)
            End If
        End If

        '* Tabelle benennen
        swTable.GetAnnotation.SetName("PASSUNGSTABELLE")
        swTable.GeneralTableFeature.GetFeature.Name = "Passungstabelle"
        textf = swTable.GetTextFormat

        th = textf.CharHeight

        textf.CharHeight = P_Form(formidx).TEXT_HIGH
        If InStr(1, P_Form(formidx).T_Art, "Italic") <> 0 Or InStr(1, P_Form(formidx).T_Art, "Kursiv") <> 0 Then
            textf.Italic = True
        Else
            textf.Italic = False
        End If
        If InStr(1, P_Form(formidx).T_Art, "Bold") <> 0 Or InStr(1, P_Form(formidx).T_Art, "Fett") <> 0 Then
            textf.Bold = True
        Else
            textf.Bold = False
        End If
        If P_Form(formidx).T_Art = "Standard" Then
            textf.Bold = False
            textf.Italic = False
        End If

        textf.Underline = P_Form(formidx).T_Unter

        textf.Strikeout = P_Form(formidx).T_Durch

        textf.TypeFaceName = P_Form(formidx).T_Stil


        swTable.SetTextFormat(False, textf)

        '* Passungen sortieren
        '* je nachdem ob die Kopfzeile unten oder oben steht
        If P_Form(formidx).HEADER = "FUSSZEILE" Then
            xx = 0
            dliste = sort_down(dliste)
        Else
            xx = 1
            dliste = sort_up(dliste)
        End If

        '* Nochmals alle Maße durchlaufen
        For i = 0 To dliste.Count - 1
            suf = Left(dliste(i), InStr(dliste(i), Chr(9)) - 1)
            t2 = Mid(dliste(i), InStr(dliste(i), Chr(9)) + 1)
            masz = Val(Left(t2, InStr(t2, Chr(9))))
            t2 = Mid(t2, InStr(t2, Chr(9)) + 1)
            pass = Left(t2, InStr(t2, Chr(9)) - 1)
            t2 = Mid(t2, InStr(t2, Chr(9)) + 1)
            tto = CDbl(Left(t2, InStr(t2, Chr(9)) - 1))
            t2 = Mid(t2, InStr(t2, Chr(9)) + 1)
            ttu = CDbl(t2)

            If P_Form(formidx).TABTYPE = 1 Or P_Form(formidx).TABTYPE = 0 Then
                If Len(suf) = 1 Then
                    swTable.Text(xx, 0) = Trim(CStr(masz))
                Else
                    swTable.Text(xx, 0) = suf + Trim(CStr(masz))
                End If
                swTable.Text(xx, 1) = pass
            Else
                If Len(suf) = 1 Then
                    swTable.Text(xx, 0) = Trim(CStr(masz))
                Else
                    swTable.Text(xx, 0) = suf + Trim(CStr(masz))
                End If
                swTable.Text(xx, 0) = swTable.Text(xx, 0) + " " + pass
            End If


            '** Toleranzen einfügen
            If P_Form(formidx).TABTYPE = 1 Or P_Form(formidx).TABTYPE = 0 Then
                tolpos = 2
            Else
                tolpos = 1
            End If

            If P_Form(formidx).TABTYPE = 1 Or P_Form(formidx).TABTYPE = 3 Or P_Form(formidx).TABTYPE = 0 Then

                '* Obere Toleranz einfügen
                If tto > 0 And P_Form(formidx).PLUS <> "" Then
                    swTable.Text(xx, tolpos) = P_Form(formidx).PLUS + Trim(CStr(tto))

                    '* Vorbearbeitungstoleranzen
                    If P_Form(formidx).SST <> 0 Then
                        If Asc(pass) >= 97 And Asc(pass) <= 122 Then
                            If CDbl(Trim(CStr(tto - P_Form(formidx).SST_V * 2))) < 0 Then
                                '* Schichtstärke *2
                                swTable.Text(xx, tolpos + tolpos) = Trim(CStr(tto - P_Form(formidx).SST_V * 2))
                            Else
                                swTable.Text(xx, tolpos + tolpos) = P_Form(formidx).PLUS + Trim(CStr(tto - P_Form(formidx).SST_V * 2))
                            End If
                        Else
                            If CDbl(Trim(CStr(tto + P_Form(formidx).SST_V * 2))) < 0 Then
                                swTable.Text(xx, tolpos + tolpos) = Trim(CStr(tto + P_Form(formidx).SST_V * 2))
                            Else
                                swTable.Text(xx, tolpos + tolpos) = P_Form(formidx).PLUS + Trim(CStr(tto + P_Form(formidx).SST_V * 2))
                            End If
                        End If
                    End If

                Else
                    swTable.Text(xx, tolpos) = tto

                    '* Vorbearbeitungstoleranzen
                    If P_Form(formidx).SST <> 0 Then
                        If Asc(pass) >= 97 And Asc(pass) <= 122 Then
                            If P_Form(formidx).PLUS <> "" Then
                                If tto - P_Form(formidx).SST_V * 2 < 0 Then
                                    swTable.Text(xx, tolpos + tolpos) = tto - P_Form(formidx).SST_V * 2
                                Else
                                    swTable.Text(xx, tolpos + tolpos) = P_Form(formidx).PLUS + Trim(CStr(tto - P_Form(formidx).SST_V * 2))
                                End If
                            Else
                                swTable.Text(xx, tolpos + tolpos) = tto - P_Form(formidx).SST_V * 2
                            End If
                        Else
                            If P_Form(formidx).PLUS <> "" Then
                                If tto + P_Form(formidx).SST_V * 2 < 0 Then
                                    swTable.Text(xx, tolpos + tolpos) = tto + P_Form(formidx).SST_V * 2
                                Else
                                    swTable.Text(xx, tolpos + tolpos) = P_Form(formidx).PLUS + Trim(CStr(tto + P_Form(formidx).SST_V * 2))
                                End If
                            Else
                                swTable.Text(xx, tolpos + tolpos) = tto + P_Form(formidx).SST_V * 2
                            End If
                        End If
                    End If

                End If

                '* Untere Toleranz einfügen
                If ttu > 0 And P_Form(formidx).PLUS <> "" Then
                    swTable.Text(xx + 1, tolpos) = P_Form(formidx).PLUS + Trim(CStr(ttu))

                    '* Vorbearbeitungstoleranzen
                    If P_Form(formidx).SST <> 0 Then
                        If Asc(pass) >= 97 And Asc(pass) <= 122 Then
                            If CDbl(Trim(CStr(ttu - P_Form(formidx).SST_V * 2))) < 0 Then
                                swTable.Text(xx + 1, tolpos + tolpos) = Trim(CStr(ttu - P_Form(formidx).SST_V * 2))
                            Else
                                swTable.Text(xx + 1, tolpos + tolpos) = P_Form(formidx).PLUS + Trim(CStr(ttu - P_Form(formidx).SST_V * 2))
                            End If
                        Else
                            If CDbl(Trim(CStr(ttu + P_Form(formidx).SST_V * 2))) < 0 Then
                                swTable.Text(xx + 1, tolpos + tolpos) = Trim(CStr(ttu + P_Form(formidx).SST_V * 2))
                            Else
                                swTable.Text(xx + 1, tolpos + tolpos) = P_Form(formidx).PLUS + Trim(CStr(ttu + P_Form(formidx).SST_V * 2))
                            End If
                        End If
                    End If

                Else
                    swTable.Text(xx + 1, tolpos) = ttu

                    '* Vorbearbeitungstoleranzen
                    If P_Form(formidx).SST <> 0 Then
                        If Asc(pass) >= 97 And Asc(pass) <= 122 Then
                            If P_Form(formidx).PLUS <> "" Then
                                If ttu - P_Form(formidx).SST_V * 2 < 0 Then
                                    swTable.Text(xx + 1, tolpos + tolpos) = ttu - P_Form(formidx).SST_V * 2
                                Else
                                    swTable.Text(xx + 1, tolpos + tolpos) = P_Form(formidx).PLUS + Trim(CStr(ttu - P_Form(formidx).SST_V * 2))
                                End If
                            Else
                                swTable.Text(xx + 1, tolpos + tolpos) = ttu - P_Form(formidx).SST_V * 2
                            End If
                        Else
                            If P_Form(formidx).PLUS <> "" Then
                                If ttu + P_Form(formidx).SST_V * 2 < 0 Then
                                    swTable.Text(xx + 1, tolpos + tolpos) = ttu + P_Form(formidx).SST_V * 2
                                Else
                                    swTable.Text(xx + 1, tolpos + tolpos) = P_Form(formidx).PLUS + Trim(CStr(ttu + P_Form(formidx).SST_V * 2))
                                End If
                            Else
                                swTable.Text(xx + 1, tolpos + tolpos) = ttu + P_Form(formidx).SST_V * 2
                            End If
                        End If
                    End If
                End If

            End If

            If P_Form(formidx).TABTYPE = 1 Or P_Form(formidx).TABTYPE = 0 Then
                swTable.Text(xx, 3) = masz + tto
                swTable.Text(xx + 1, 3) = masz + ttu
                If P_Form(formidx).SST <> 0 Then
                    If Asc(pass) >= 97 And Asc(pass) <= 122 Then
                        swTable.Text(xx, 5) = masz + tto - P_Form(formidx).SST_V * 2
                        swTable.Text(xx + 1, 5) = masz + ttu - P_Form(formidx).SST_V * 2
                    Else
                        swTable.Text(xx, 5) = masz + tto + P_Form(formidx).SST_V * 2
                        swTable.Text(xx + 1, 5) = masz + ttu + P_Form(formidx).SST_V * 2
                    End If
                End If
            ElseIf P_Form(formidx).TABTYPE = 2 Then
                swTable.Text(xx, 1) = masz + tto
                swTable.Text(xx + 1, 1) = masz + ttu

                If P_Form(formidx).SST <> 0 Then
                    If Asc(pass) >= 97 And Asc(pass) <= 122 Then
                        swTable.Text(xx, 2) = masz + tto - P_Form(formidx).SST_V * 2
                        swTable.Text(xx + 1, 2) = masz + ttu - P_Form(formidx).SST_V * 2
                    Else
                        swTable.Text(xx, 2) = masz + tto + P_Form(formidx).SST_V * 2
                        swTable.Text(xx + 1, 2) = masz + ttu + P_Form(formidx).SST_V * 2
                    End If
                End If
            End If

            If P_Form(formidx).TABTYPE = 1 Or P_Form(formidx).TABTYPE = 0 Then
                swTable.MergeCells(xx, 0, xx + 1, 0)
                swTable.MergeCells(xx, 1, xx + 1, 1)
            Else
                swTable.MergeCells(xx, 0, xx + 1, 0)
            End If

            If P_Form(formidx).TABTYPE = 1 Or P_Form(formidx).TABTYPE = 0 Then
                If P_Form(formidx).SST = 0 And P_Form(formidx).SHOW_ZONES = 1 Then
                    swTable.Text(xx, 4) = pass_lst(i).zones
                    swTable.MergeCells(xx, 4, xx + 1, 4)
                End If
                If P_Form(formidx).SST <> 0 And P_Form(formidx).SHOW_ZONES = 1 Then
                    swTable.Text(xx, 5) = pass_lst(i).zones
                    swTable.MergeCells(xx, 5, xx + 1, 5)
                End If
            End If
            If P_Form(formidx).TABTYPE = 2 Then
                If P_Form(formidx).SST = 0 And P_Form(formidx).SHOW_ZONES = 1 Then
                    swTable.Text(xx, 2) = pass_lst(i).zones
                    swTable.MergeCells(xx, 2, xx + 1, 2)
                End If
                If P_Form(formidx).SST <> 0 And P_Form(formidx).SHOW_ZONES = 1 Then
                    swTable.Text(xx, 3) = pass_lst(i).zones
                    swTable.MergeCells(xx, 2, xx + 1, 2)
                End If
            End If
            If P_Form(formidx).TABTYPE = 3 Then
                If P_Form(formidx).SST = 0 And P_Form(formidx).SHOW_ZONES = 1 Then
                    swTable.Text(xx, 2) = pass_lst(i).zones
                    swTable.MergeCells(xx, 2, xx + 1, 2)
                End If
                If P_Form(formidx).SST <> 0 And P_Form(formidx).SHOW_ZONES = 1 Then
                    swTable.Text(xx, 3) = pass_lst(i).zones
                    swTable.MergeCells(xx, 2, xx + 1, 2)
                End If
            End If



            xx = xx + 2
        Next

        '* Spaltenüberschriften einfügen
        If P_Form(formidx).HEADER = "FUSSZEILE" Then
            swTable.SetHeader(swTableHeaderPosition_e.swTableHeader_Bottom, 1)
            swTable.MergeCells(xx, 1, xx, 3)
            If P_Form(formidx).SST <> 0 Then swTable.MergeCells(xx, 4, xx, 5)
        Else
            swTable.SetHeader(swTableHeaderPosition_e.swTableHeader_Top, 1)
            swTable.MergeCells(0, 1, 0, 3)
            If P_Form(formidx).SST <> 0 Then swTable.MergeCells(0, 4, 0, 5)
        End If

        format = P_Form(formidx)
        langg = get_lang(format.HEADER_LANG)


        If P_Form(formidx).TABTYPE = 1 Or P_Form(formidx).TABTYPE = 0 Then
            swTable.SetColumnTitle(0, langg.masz)
            swTable.SetColumnTitle(1, langg.pass)
            If P_Form(formidx).SST <> 0 And P_Form(formidx).SHOW_ZONES = 0 Then swTable.SetColumnTitle(4, langg.vor)
            If P_Form(formidx).SST = 0 And P_Form(formidx).SHOW_ZONES = 1 Then swTable.SetColumnTitle(4, langg.zon)
            If P_Form(formidx).SST <> 0 And P_Form(formidx).SHOW_ZONES = 1 Then
                swTable.SetColumnTitle(4, langg.vor)
                swTable.SetColumnTitle(5, langg.zon)
            End If
        ElseIf P_Form(formidx).TABTYPE = 2 Then
            swTable.SetColumnTitle(0, langg.pass)
            swTable.SetColumnTitle(1, langg.Abm)
            If P_Form(formidx).SST <> 0 And P_Form(formidx).SHOW_ZONES = 0 Then swTable.SetColumnTitle(2, langg.vor)
            If P_Form(formidx).SST = 0 And P_Form(formidx).SHOW_ZONES = 1 Then swTable.SetColumnTitle(2, langg.zon)
            If P_Form(formidx).SST <> 0 And P_Form(formidx).SHOW_ZONES = 1 Then
                swTable.SetColumnTitle(2, langg.vor)
                swTable.SetColumnTitle(3, langg.zon)
            End If
        Else
            swTable.SetColumnTitle(0, langg.pass)
            swTable.SetColumnTitle(1, langg.Tol)
            If P_Form(formidx).SST <> 0 And P_Form(formidx).SHOW_ZONES = 0 Then swTable.SetColumnTitle(2, langg.vor)
            If P_Form(formidx).SST = 0 And P_Form(formidx).SHOW_ZONES = 1 Then swTable.SetColumnTitle(2, langg.zon)
            If P_Form(formidx).SST <> 0 And P_Form(formidx).SHOW_ZONES = 1 Then
                swTable.SetColumnTitle(2, langg.vor)
                swTable.SetColumnTitle(3, langg.zon)
            End If
        End If


        '* Tabelle anpassen
        '* Zur Zeit nicht wirklich befriedigend :-(
        th = swTable.GetRowHeight(0)
        swTable.SetRowHeight(swTableCellRangeIdentifier_e.swTableCellRange_All, P_Form(formidx).TEXT_HIGH * 1.5, swTableRowColSizeChangeBehavior_e.swTableRowColChange_TableSizeCanChange)
        th = swTable.GetColumnWidth(0)
        swTable.SetCellRange(0, xx + 1, 0, 0)


        swTable.SetColumnWidth(0, P_Form(formidx).CW1, swTableRowColSizeChangeBehavior_e.swTableRowColChange_TableSizeCanChange)
        th = swTable.GetColumnWidth(1)
        swTable.SetCellRange(0, xx + 1, 1, 1)


        swTable.SetColumnWidth(1, P_Form(formidx).CW2, swTableRowColSizeChangeBehavior_e.swTableRowColChange_TableSizeCanChange)
        th = swTable.GetColumnWidth(2)
        swTable.SetCellRange(0, xx + 1, 2, 2)


        swTable.SetColumnWidth(2, P_Form(formidx).CW3, swTableRowColSizeChangeBehavior_e.swTableRowColChange_TableSizeCanChange)
        th = swTable.GetColumnWidth(3)
        swTable.SetCellRange(0, xx + 1, 3, 3)


        swTable.SetColumnWidth(3, P_Form(formidx).CW4, swTableRowColSizeChangeBehavior_e.swTableRowColChange_TableSizeCanChange)
        th = swTable.GetColumnWidth(4)
        swTable.SetCellRange(0, xx + 1, 4, 4)


        swTable.SetColumnWidth(4, P_Form(formidx).CW3, swTableRowColSizeChangeBehavior_e.swTableRowColChange_TableSizeCanChange)
        th = swTable.GetColumnWidth(5)
        swTable.SetCellRange(0, xx + 1, 5, 5)


        swTable.SetColumnWidth(5, P_Form(formidx).CW4, swTableRowColSizeChangeBehavior_e.swTableRowColChange_TableSizeCanChange)

        swTable.BorderLineWeight = P_Form(formidx).TABBorder - 1
        swTable.GridLineWeight = P_Form(formidx).TABGrid - 1

        If leere_gefunden = True And P_Form(formidx).Empty_Pass = "warn" Then
            swmodel.Extension.MultiSelect(objs, True, Nothing)
        End If

        formate.Clear()
        sprachen.Clear()
        P_Form.Clear()
    End Sub

End Module
